/*
  temperture sensing Simple Project.c
   
*/


#include "simpletools.h"                      // Include simple tools
#include "c:/propgcc/propeller-elf/include/i2c.h"


 
int main()                                    // Main function
{
  long freq          = 100000 ;     
  int  i2cSDA        = 5;                     // pin 5
  int  i2cSCL        = 3;                     // pin 3
  int DS1721_Addr      = 146;                 // ds1721 address 10010010
  int DS1721_Addr_Read = 147;                 // ds1721 address +1 for read

  int ReadTemp      = 0xAA;
  int AccessTH      = 0xA1;
  int AccessTL      = 0xA2;
  int AccessConfig  = 0xAC;
  int ReadCounter   = 0xA8;
  int ReadScope     = 0xA9;
  int StartConvert  = 0x51;
  int StopConvert   = 0x22;
  int OneShotMode   = 1;
  int Cont_09_Bit   = 0x00; 
  
  //I2C_SIMPLE *  i2c_Address;
  I2C *  i2c_Address;
    int cog = 3;

  //I2C_COGDRIVER * Cog
 struct I2C_COGDRIVER
    {
    I2C * i2c_Address;
     int cog ;
    volatile I2C_MAILBOX mailbox;
     } * COG ;

  int flag = 2;
  int tempvar = 0;
  const int  True  = 1;
  const int False = 0;

  pause (1000);


    printf("starting\n");

    // simple_i2cOpen( i2c_Address,i2cSCL,i2cSDA);     // get a i2c address for the ds1721 chip

      i2c_Address = i2cOpen(COG, i2cSCL, i2cSDA, freq);

      flag = i2cWrite(i2c_Address,DS1721_Addr,AccessConfig,1,False);  // tell DS1721 we are going to config
  
      if (flag == 0)
          printf("Success on config \n");
      
      if (flag == -1)
          printf("Failure on config\n");
      pause (1000);
      flag = 2;
 

      flag = i2cWrite(i2c_Address,DS1721_Addr,Cont_09_Bit,1,True);  // tell DS1721 9 bit accuracy
       if (flag == 0)
          printf("Success on 9 bit\n");
        if (flag == -1)
          printf("Failure on 9 bit\n");
 
      pause (1000);
      flag = 2;
     
     flag = i2cWrite(i2c_Address,DS1721_Addr,StartConvert,1,True); // start conversion process
     if (flag == 0)
          printf("success on starting conversion of temp\n");
      if (flag == -1)
          printf("Failure on starting conversion of temp\n");  
   
      pause (1000);
    

      

  while(1)                                    // Repeat indefinitely
  {
    flag = 2;

    flag = i2cWrite(i2c_Address,DS1721_Addr,ReadTemp,1,True);        // tell ds1721 i am going to read the temperture
        if (flag == 0)
          printf("success on starting reading of temp \n");
         if (flag == -1)
          printf("Failure on starting reading of temp\n");

    pause (1000);

    flag = 2;

    flag = i2cRead(i2c_Address,DS1721_Addr_Read,&tempvar,1,False);   // reading MSB
        if (flag == 0)
          printf("success on reading of temp\n %d\n",tempvar);
         if (flag == -1)
          printf("Failure on reading of temp\n");

    pause(1000);

    //flag = 2;

    //flag = i2cRead(i2c_Address,DS1721_Addr_Read,tempvar,1,True);   // reading LSB
    //    if (flag == 0)
    //      printf("success on reading of LSB temp %d\n",tempvar);
    //    if (flag == -1)
    //      printf("Failure on reading of LSB temp\n");

   // pause(1000);

    tempvar = ((tempvar * 9) / 5) + 32;
    printf("%d\n",tempvar);          // output to screen

   pause(1500);       //wait 1.5 sec before resample  
                               // ( min wait is 1.2 sec )
    tempvar = 10 ;
    
  }  
}
